// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release

class CProperty;
class CRequest;
class CRequests;
    
class FAR CProperties : public _IProperties
{

friend CRequest;
friend CRequests;
friend CCache;

public:		
   	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
   	STDMETHOD_(ULONG, AddRef)();
   	STDMETHOD_(ULONG, Release)();

    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);

public:
	//Custom methods
    STDMETHOD_(long, get_Count)(void);
    STDMETHOD_(LPUNKNOWN, get__NewEnum)(void);
	STDMETHOD_(IDispatch *,get_DataObject)(void);                                                                            
    STDMETHOD_(IDispatch *, Add)(VARIANT Name);
    STDMETHOD_(IDispatch *, get_Item)(VARIANT Index);
    STDMETHOD_(void, Remove)(VARIANT Index);
    STDMETHOD_(void, Reset)(void);
    STDMETHOD_(IDispatch *, get_Object)(void);
	
	HRESULT AddExistingProps(CProperties FAR *pSrcProps); 
	HRESULT Add(VARIANT Name, CProperty FAR* FAR* ppProperty, CNode FAR* FAR* ppNode);

    static HRESULT Create(CProperties FAR* FAR* ppProperties) ; // Creates and intializes Collection   

    CProperties();
    ~CProperties();

private:
	HRESULT XRTItem(VARIANT FAR *pvIndex, LPDISPATCH FAR *ppDispatch);
	HRESULT XRTAdd(VARIANT FAR *pvName, LPDISPATCH FAR *ppDispatch);
	HRESULT XRTRemove(VARIANT FAR *pvIndex);

private:
	CDataObject FAR *			m_pDataObject;              
	LPDISPATCH					m_pXRTDispatch;
	CRequest FAR *				m_pRequest;
	CCollection					m_col;
	BSTR						m_bstrName;
	LPTYPEINFO					m_ptinfo;
	ULONG						m_cRef;
   	EXCEPINFO 					m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 						m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
};
