// IPERFILE.H
//
// XRTOBJ32 is a sample application that illustrates how to build
// a simple IDataObject centric OLE 2.0 object.  
//
// Copyright (c) 1993 Microsoft Corporation, All Rights Reserved.
//
// WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
//
// WARNING: This sample does not support the REAL WOSA/XRT
//          specification!   It is an early prototype that is
//          included in the SDK because it illustrates how
//          to do Uniform Data Transfer without using MFC.
//
//          This sample DOES NOT support Version 1.0 of the
//          WOSA/XRT Design Specification.  It does not
//          use the real WOSA/XRT Clipboard format.
//          It does not implement the WOSA/XRT Programmability
//          Interface (in fact it doesn't even support IDispatch).
//
//          Use this sample to learn about Uniform Data Transfer
//          (IDataObject and IAdviseSink).
//
// WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
//
// See README.TXT for more info.
//
// Revisions:
//  July 15, 1993   cek     First implementation.
//
// Implementation Notes:
//
//  Stolen directly out of KraigB's Chapter 6 code.
//
#ifndef _IPERFILE_H_
#define _IPERFILE_H_


class FAR CImpIPersistFile : public IPersistFile
{
protected:
    ULONG               m_cRef ;      //Interface reference count.
    LPVOID              m_pObj ;      //Back pointer to the object.
    LPUNKNOWN           m_punkOuter ; //Controlling unknown for delegation.

public:
    CImpIPersistFile(LPVOID, LPUNKNOWN) ;
    ~CImpIPersistFile(void) ;

    STDMETHODIMP QueryInterface(REFIID, LPVOID FAR *) ;
    STDMETHODIMP_(ULONG) AddRef(void) ;
    STDMETHODIMP_(ULONG) Release(void) ;

    STDMETHODIMP GetClassID(LPCLSID) ;

    STDMETHODIMP IsDirty(void) ;
    STDMETHODIMP Load(LPCTSTR, DWORD) ;
    STDMETHODIMP Save(LPCTSTR, BOOL) ;
    STDMETHODIMP SaveCompleted(LPCTSTR) ;
    STDMETHODIMP GetCurFile(LPTSTR FAR *);
} ;

typedef CImpIPersistFile * LPCIMPIPERSISTFILE ;


#endif  //_IPERFILE_H_
